> For the complete documentation index, see [llms.txt](https://docs.devolutions.net/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.devolutions.net/powershell/remote-desktop-manager-powershell/powershell-scripting/powershell-module/powershell-samples-creating-folder-structure-from-csv-file.md).

# PowerShell samples - creating folder structure from CSV file

Run a PowerShell sample script to automatically create a Remote Desktop Manager Group Folder structure from a UTF-8 encoded CSV file.

{% hint style="info" %}
Please note that the CSV file must be encoded in UTF-8 to support special characters.
{% endhint %}

This sample creates a Group Folder structure from a CSV file.

### Sample

```powershell
$csv = Import-Csv "c:\YourFolder\GroupFolder.csv"

foreach ($csvEntry in $csv) {
        $groupName = $csvEntry.Name

    # Extract the group folder name
    if ($groupName.Contains("\")) {
         $groupName = $groupName.Substring($groupName.LastIndexOf("\"), $groupName.Length - $groupName.LastIndexOf("\"))
         $groupName = $groupName.TrimStart("\")
        }

    # Create the group folder if it is not null, empty or fill in with space characters
    if (![]::IsNullOrWhiteSpace($groupName)) {
        $session = New-RDMSession -Type "Group" -Name $groupName
        $session.Group = $csvEntry.Name
        Set-RDMSession $session
        Write-Host "Group Folder $groupName created" -f Yellow
        }
}

Update-RDMUI
```

### Notes

The CSV file must have only one column with the title set as Name.

The full path must be specified for each sub folder.

Here is an example of this CSV file:

```csv
Name
A
A\B
A\B\C
D
D\E
D\E\F
G
G\H
G\H\I
G\H\I\J
G\H\I\J\K
G\H\I\J\K\L
Test
Test\Sample
Test\Sample\Folder
Test\Sample\Folder\Sub folder
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.devolutions.net/powershell/remote-desktop-manager-powershell/powershell-scripting/powershell-module/powershell-samples-creating-folder-structure-from-csv-file.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
